Index: plugins/org.jboss.tools.maven.cdi/src/org/jboss/tools/maven/cdi/CDILifecycleMapping.java
===================================================================
--- plugins/org.jboss.tools.maven.cdi/src/org/jboss/tools/maven/cdi/CDILifecycleMapping.java	(revision 0)
+++ plugins/org.jboss.tools.maven.cdi/src/org/jboss/tools/maven/cdi/CDILifecycleMapping.java	(revision 0)
@@ -0,0 +1,20 @@
+/*******************************************************************************
+ * Copyright (c) 2011 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.maven.cdi;
+
+import org.eclipse.m2e.core.project.configurator.AbstractCustomizableLifecycleMapping;
+
+/**
+ * @author snjeza
+ */
+public class CDILifecycleMapping extends AbstractCustomizableLifecycleMapping {
+
+}
Index: plugins/org.jboss.tools.maven.cdi/src/org/jboss/tools/maven/cdi/configurators/CDIProjectConfigurator.java
===================================================================
--- plugins/org.jboss.tools.maven.cdi/src/org/jboss/tools/maven/cdi/configurators/CDIProjectConfigurator.java	(revision 32612)
+++ plugins/org.jboss.tools.maven.cdi/src/org/jboss/tools/maven/cdi/configurators/CDIProjectConfigurator.java	(working copy)
@@ -1,47 +1,73 @@
+/*************************************************************************************
+ * Copyright (c) 2008-2011 Red Hat, Inc. and others.
+ * All rights reserved. This program and the accompanying materials 
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ * 
+ * Contributors:
+ *     JBoss by Red Hat - Initial implementation.
+ ************************************************************************************/
 package org.jboss.tools.maven.cdi.configurators;
 
+import java.util.List;
+
+import org.apache.maven.artifact.Artifact;
+import org.apache.maven.artifact.repository.ArtifactRepository;
 import org.apache.maven.project.MavenProject;
 import org.eclipse.core.resources.IProject;
 import org.eclipse.core.runtime.CoreException;
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.NullProgressMonitor;
 import org.eclipse.jface.preference.IPreferenceStore;
+import org.eclipse.m2e.core.project.IMavenProjectFacade;
+import org.eclipse.m2e.core.project.MavenProjectChangedEvent;
+import org.eclipse.m2e.core.project.configurator.AbstractProjectConfigurator;
+import org.eclipse.m2e.core.project.configurator.ProjectConfigurationRequest;
+import org.eclipse.osgi.util.NLS;
 import org.eclipse.wst.common.componentcore.ModuleCoreNature;
 import org.eclipse.wst.common.frameworks.datamodel.IDataModel;
 import org.eclipse.wst.common.project.facet.core.IFacetedProject;
 import org.eclipse.wst.common.project.facet.core.IProjectFacet;
 import org.eclipse.wst.common.project.facet.core.IProjectFacetVersion;
 import org.eclipse.wst.common.project.facet.core.ProjectFacetsManager;
+import org.jboss.tools.cdi.core.CDICoreNature;
 import org.jboss.tools.cdi.core.CDIUtil;
 import org.jboss.tools.maven.cdi.MavenCDIActivator;
+import org.jboss.tools.maven.cdi.Messages;
 import org.jboss.tools.maven.core.IJBossMavenConstants;
 import org.jboss.tools.maven.core.internal.project.facet.MavenFacetInstallDataModelProvider;
 import org.jboss.tools.maven.ui.Activator;
-import org.jboss.tools.maven.cdi.Messages;
-import org.maven.ide.eclipse.project.IMavenProjectFacade;
-import org.maven.ide.eclipse.project.MavenProjectChangedEvent;
-import org.maven.ide.eclipse.project.configurator.AbstractProjectConfigurator;
-import org.maven.ide.eclipse.project.configurator.ProjectConfigurationRequest;
 
+/**
+ * 
+ * @author snjeza
+ *
+ */
 public class CDIProjectConfigurator extends AbstractProjectConfigurator {
 
 	private static final String CDI_API_GROUP_ID = "javax.enterprise"; //$NON-NLS-1$
 	private static final String CDI_API_ARTIFACT_ID = "cdi-api"; //$NON-NLS-1$
 	
 	protected static final IProjectFacet dynamicWebFacet;
+	protected static final IProjectFacet ejbFacet;
 	protected static final IProjectFacetVersion dynamicWebVersion;
+	protected static final IProjectFacetVersion ejbVersion;
 	
 	protected static final IProjectFacet cdiFacet;
 	protected static final IProjectFacetVersion cdiVersion;
 	
 	protected static final IProjectFacet m2Facet;
 	protected static final IProjectFacetVersion m2Version;
+	private static final String DEFAULT_CDI_VERSION = "1.0";
 	
 	static {
 		dynamicWebFacet = ProjectFacetsManager.getProjectFacet("jst.web"); //$NON-NLS-1$
 		dynamicWebVersion = dynamicWebFacet.getVersion("2.5");  //$NON-NLS-1$
+		ejbFacet = ProjectFacetsManager.getProjectFacet("jst.ejb"); //$NON-NLS-1$
+		ejbVersion = ejbFacet.getVersion("3.0");  //$NON-NLS-1$
 		cdiFacet = ProjectFacetsManager.getProjectFacet("jst.cdi"); //$NON-NLS-1$
-		cdiVersion = cdiFacet.getVersion("1.0"); //$NON-NLS-1$
+		cdiVersion = cdiFacet.getVersion(DEFAULT_CDI_VERSION); //$NON-NLS-1$
 		m2Facet = ProjectFacetsManager.getProjectFacet("jboss.m2"); //$NON-NLS-1$
 		m2Version = m2Facet.getVersion("1.0"); //$NON-NLS-1$
 	}
@@ -61,13 +87,17 @@
 		if (!configureCDI) {
 			return;
 		}
-		
+    	final IFacetedProject fproj = ProjectFacetsManager.create(project);
+		if (project.hasNature(CDICoreNature.NATURE_ID) 
+				&& (fproj == null || (fproj.hasProjectFacet(cdiFacet) && fproj.hasProjectFacet(m2Facet)))) {
+			//everything already installed. Since there's no support for version update -yet- we stop here
+			return;
+		}
 		String packaging = mavenProject.getPackaging();
 	    String cdiVersion = getCDIVersion(mavenProject);
 	    if (cdiVersion != null) {
-	    	final IFacetedProject fproj = ProjectFacetsManager.create(project);
 	    	if ( (fproj != null) && ("war".equals(packaging) || "ejb".equals(packaging)) ) { //$NON-NLS-1$
-	    		installWarFacets(fproj, cdiVersion, monitor);
+	    		installDefaultFacets(fproj, cdiVersion, monitor);
 	    	}
 	    	CDIUtil.enableCDI(project, false, new NullProgressMonitor());
 	    }
@@ -101,12 +131,21 @@
 	}
 
 	
-	private void installWarFacets(IFacetedProject fproj, String cdiVersion,IProgressMonitor monitor) throws CoreException {
+	@SuppressWarnings("unchecked")
+	private void installDefaultFacets(IFacetedProject fproj, String cdiVersion,IProgressMonitor monitor) throws CoreException {
+		IProjectFacetVersion currentWebVersion = fproj.getProjectFacetVersion(dynamicWebFacet); 
+		IProjectFacetVersion currentEjbVersion = fproj.getProjectFacetVersion(ejbFacet); 
 		
-		if (!fproj.hasProjectFacet(dynamicWebFacet)) {
-			MavenCDIActivator.log(Messages.CDIProjectConfigurator_The_project_does_not_contain_the_Web_Module_facet);
+		if ((currentWebVersion != null && currentWebVersion.compareTo(dynamicWebVersion)> -1)
+				|| (currentEjbVersion != null && currentEjbVersion.compareTo(ejbVersion)> -1)) {
+			installCDIFacet(fproj, cdiVersion, monitor);
+		} else {
+			String name = "";
+			if (fproj.getProject() != null) {
+				name = fproj.getProject().getName();
+			}
+			MavenCDIActivator.log(NLS.bind(Messages.CDIProjectConfigurator_The_project_does_not_contain_required_facets, name));
 		}
-		installCDIFacet(fproj, cdiVersion, monitor);
 		installM2Facet(fproj, monitor);
 		
 	}
@@ -123,10 +162,37 @@
 	}
 	
 	private String getCDIVersion(MavenProject mavenProject) {
-		String version = null;
-		version = Activator.getDefault().getDependencyVersion(mavenProject, CDI_API_GROUP_ID, CDI_API_ARTIFACT_ID);
-		
+		String version = Activator.getDefault().getDependencyVersion(mavenProject, CDI_API_GROUP_ID, CDI_API_ARTIFACT_ID);
+		if (version == null) {
+			version = inferCdiVersionFromDependencies(mavenProject);
+		}
 	    return version;
 	}
 
+	private String inferCdiVersionFromDependencies(MavenProject mavenProject) {
+		boolean hasCandidates = false;
+		String cdiVersion = null;
+		List<ArtifactRepository> repos = mavenProject.getRemoteArtifactRepositories();
+		for (Artifact artifact : mavenProject.getArtifacts()) {
+			if (isKnownCdiExtension(artifact)) {
+				hasCandidates = true;
+				cdiVersion = Activator.getDefault().getDependencyVersion(artifact, repos, CDI_API_GROUP_ID, CDI_API_ARTIFACT_ID);
+				if (cdiVersion != null) {
+					//TODO should probably not break and take the highest version returned from all dependencies
+					break;
+				}
+			}
+		}
+		//Fallback to default CDI version
+		if (hasCandidates && cdiVersion == null) {
+			return DEFAULT_CDI_VERSION;
+		}
+		return cdiVersion;
+	}
+
+	private boolean isKnownCdiExtension(Artifact artifact) {
+		return artifact.getGroupId().startsWith("org.jboss.seam.") 
+			&& artifact.getVersion().startsWith("3.");
+	}
+
 }
Index: plugins/org.jboss.tools.maven.cdi/src/org/jboss/tools/maven/cdi/MavenCDIActivator.java
===================================================================
--- plugins/org.jboss.tools.maven.cdi/src/org/jboss/tools/maven/cdi/MavenCDIActivator.java	(revision 32612)
+++ plugins/org.jboss.tools.maven.cdi/src/org/jboss/tools/maven/cdi/MavenCDIActivator.java	(working copy)
@@ -1,3 +1,13 @@
+/*************************************************************************************
+ * Copyright (c) 2008-2011 Red Hat, Inc. and others.
+ * All rights reserved. This program and the accompanying materials 
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ * 
+ * Contributors:
+ *     JBoss by Red Hat - Initial implementation.
+ ************************************************************************************/
 package org.jboss.tools.maven.cdi;
 
 import org.eclipse.core.runtime.IStatus;
Index: plugins/org.jboss.tools.maven.cdi/META-INF/MANIFEST.MF
===================================================================
--- plugins/org.jboss.tools.maven.cdi/META-INF/MANIFEST.MF	(revision 32612)
+++ plugins/org.jboss.tools.maven.cdi/META-INF/MANIFEST.MF	(working copy)
@@ -2,14 +2,13 @@
 Bundle-ManifestVersion: 2
 Bundle-Name: %Bundle-Name
 Bundle-SymbolicName: org.jboss.tools.maven.cdi;singleton:=true
-Bundle-Version: 1.0.0.qualifier
+Bundle-Version: 1.2.0.qualifier
 Bundle-Activator: org.jboss.tools.maven.cdi.MavenCDIActivator
 Require-Bundle: org.eclipse.ui,
  org.eclipse.core.runtime,
  org.jboss.tools.maven.core,
  org.jboss.tools.maven.ui,
  org.jboss.tools.common.model,
- org.maven.ide.eclipse.maven_model_edit;bundle-version="0.10.0";visibility:=reexport,
  org.eclipse.jst.j2ee.core,
  org.eclipse.jst.j2ee,
  org.eclipse.wst.common.emfworkbench.integration,
Index: plugins/org.jboss.tools.maven.project.examples/META-INF/MANIFEST.MF
===================================================================
--- plugins/org.jboss.tools.maven.project.examples/META-INF/MANIFEST.MF	(revision 32612)
+++ plugins/org.jboss.tools.maven.project.examples/META-INF/MANIFEST.MF	(working copy)
@@ -9,7 +9,9 @@
  org.eclipse.core.runtime,
  org.jboss.tools.maven.core,
  org.jboss.tools.project.examples,
- org.eclipse.ui.ide
+ org.eclipse.ui.ide,
+ org.eclipse.m2e.archetype.common;bundle-version="[1.0,1.1)",
+ org.eclipse.m2e.core.ui;bundle-version="[1.0,1.1)"
 Bundle-ActivationPolicy: lazy
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
 Bundle-Vendor: %Bundle-Vendor
Index: plugins/org.jboss.tools.maven.project.examples/src/org/jboss/tools/maven/project/examples/ImportMavenProjectExample.java
===================================================================
--- plugins/org.jboss.tools.maven.project.examples/src/org/jboss/tools/maven/project/examples/ImportMavenProjectExample.java	(revision 32612)
+++ plugins/org.jboss.tools.maven.project.examples/src/org/jboss/tools/maven/project/examples/ImportMavenProjectExample.java	(working copy)
@@ -11,7 +11,6 @@
 
 package org.jboss.tools.maven.project.examples;
 
-import java.io.BufferedOutputStream;
 import java.io.File;
 import java.io.FileOutputStream;
 import java.io.IOException;
@@ -26,7 +25,6 @@
 
 import org.apache.maven.model.Model;
 import org.eclipse.core.resources.IProject;
-import org.eclipse.core.resources.IProjectDescription;
 import org.eclipse.core.resources.IResource;
 import org.eclipse.core.resources.IWorkspace;
 import org.eclipse.core.resources.IWorkspaceRoot;
@@ -36,29 +34,22 @@
 import org.eclipse.core.runtime.IPath;
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.IStatus;
-import org.eclipse.core.runtime.Path;
 import org.eclipse.core.runtime.Status;
 import org.eclipse.core.runtime.jobs.Job;
-import org.eclipse.jface.dialogs.Dialog;
-import org.eclipse.jface.dialogs.IDialogConstants;
 import org.eclipse.jface.dialogs.MessageDialog;
+import org.eclipse.m2e.core.MavenPlugin;
+import org.eclipse.m2e.core.embedder.IMaven;
+import org.eclipse.m2e.core.embedder.MavenModelManager;
+import org.eclipse.m2e.core.project.AbstractProjectScanner;
+import org.eclipse.m2e.core.project.LocalProjectScanner;
+import org.eclipse.m2e.core.project.MavenProjectInfo;
+import org.eclipse.m2e.core.project.ProjectImportConfiguration;
+import org.eclipse.m2e.core.ui.internal.actions.OpenMavenConsoleAction;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.Shell;
 import org.eclipse.ui.progress.IProgressConstants;
 import org.jboss.tools.project.examples.model.AbstractImportProjectExample;
 import org.jboss.tools.project.examples.model.Project;
-import org.maven.ide.eclipse.MavenPlugin;
-import org.maven.ide.eclipse.actions.OpenMavenConsoleAction;
-import org.maven.ide.eclipse.core.IMavenConstants;
-import org.maven.ide.eclipse.core.MavenConsole;
-import org.maven.ide.eclipse.embedder.IMaven;
-import org.maven.ide.eclipse.embedder.MavenModelManager;
-import org.maven.ide.eclipse.project.AbstractProjectScanner;
-import org.maven.ide.eclipse.project.IMavenProjectImportResult;
-import org.maven.ide.eclipse.project.LocalProjectScanner;
-import org.maven.ide.eclipse.project.MavenProjectInfo;
-import org.maven.ide.eclipse.project.ProjectImportConfiguration;
-import org.maven.ide.eclipse.project.ResolverConfiguration;
 
 /**
  * @author snjeza
@@ -149,7 +140,6 @@
 			public IStatus runInWorkspace(IProgressMonitor monitor) {
 				setProperty(IProgressConstants.ACTION_PROPERTY,
 						new OpenMavenConsoleAction());
-				MavenPlugin plugin = MavenPlugin.getDefault();
 				try {
 					AbstractProjectScanner<MavenProjectInfo> projectScanner = getProjectScanner(destination);
 					projectScanner.run(monitor);
@@ -186,15 +176,15 @@
 									// ignore
 								}
 								project.delete(true, true, monitor);
-							}
+							}	
 						} else {
 							return Status.CANCEL_STATUS;
 						}
 					}
-					plugin.getProjectConfigurationManager().importProjects(
+					MavenPlugin.getProjectConfigurationManager().importProjects(
 							infos, importConfiguration, monitor);
 				} catch (CoreException ex) {
-					plugin.getConsole().logError("Projects imported with errors");
+					MavenProjectExamplesActivator.log(ex, "Projects imported with errors");
 					return ex.getStatus();
 				} catch (InterruptedException e) {
 					return Status.CANCEL_STATUS;
@@ -202,8 +192,7 @@
 				return Status.OK_STATUS;
 			}
 		};
-		job.setRule(MavenPlugin.getDefault().getProjectConfigurationManager()
-				.getRule());
+		job.setRule(MavenPlugin.getProjectConfigurationManager().getRule());
 		job.schedule();
 	}
 
@@ -229,11 +218,9 @@
 			File folder) {
 		File root = ResourcesPlugin.getWorkspace().getRoot().getLocation()
 				.toFile();
-		MavenPlugin mavenPlugin = MavenPlugin.getDefault();
-		MavenModelManager modelManager = mavenPlugin.getMavenModelManager();
-		MavenConsole console = mavenPlugin.getConsole();
+		MavenModelManager modelManager = MavenPlugin.getMavenModelManager();
 		return new LocalProjectScanner(root, folder.getAbsolutePath(), false,
-				modelManager, console);
+				modelManager);
 	}
 	
 	private static Shell getActiveShell() {
Index: plugins/org.jboss.tools.maven.hibernate/META-INF/MANIFEST.MF
===================================================================
--- plugins/org.jboss.tools.maven.hibernate/META-INF/MANIFEST.MF	(revision 32612)
+++ plugins/org.jboss.tools.maven.hibernate/META-INF/MANIFEST.MF	(working copy)
@@ -2,14 +2,13 @@
 Bundle-ManifestVersion: 2
 Bundle-Name: %Bundle-Name
 Bundle-SymbolicName: org.jboss.tools.maven.hibernate;singleton:=true
-Bundle-Version: 1.0.0.qualifier
+Bundle-Version: 1.2.0.qualifier
 Bundle-Activator: org.jboss.tools.maven.hibernate.MavenHibernateActivator
 Require-Bundle: org.eclipse.ui,
  org.eclipse.core.runtime,
  org.jboss.tools.maven.core,
  org.jboss.tools.maven.ui,
  org.jboss.tools.common.model,
- org.maven.ide.eclipse.maven_model_edit;bundle-version="0.10.0";visibility:=reexport,
  org.eclipse.jst.j2ee.core,
  org.eclipse.jst.j2ee,
  org.eclipse.wst.common.emfworkbench.integration,
Index: plugins/org.jboss.tools.maven.hibernate/src/org/jboss/tools/maven/hibernate/HibernateLifecycleMapping.java
===================================================================
--- plugins/org.jboss.tools.maven.hibernate/src/org/jboss/tools/maven/hibernate/HibernateLifecycleMapping.java	(revision 0)
+++ plugins/org.jboss.tools.maven.hibernate/src/org/jboss/tools/maven/hibernate/HibernateLifecycleMapping.java	(revision 0)
@@ -0,0 +1,20 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.maven.hibernate;
+
+import org.eclipse.m2e.core.project.configurator.AbstractCustomizableLifecycleMapping;
+
+/**
+ * @author snjeza
+ */
+public class HibernateLifecycleMapping extends AbstractCustomizableLifecycleMapping {
+
+}
Index: plugins/org.jboss.tools.maven.hibernate/src/org/jboss/tools/maven/hibernate/configurators/HibernateProjectConfigurator.java
===================================================================
--- plugins/org.jboss.tools.maven.hibernate/src/org/jboss/tools/maven/hibernate/configurators/HibernateProjectConfigurator.java	(revision 32612)
+++ plugins/org.jboss.tools.maven.hibernate/src/org/jboss/tools/maven/hibernate/configurators/HibernateProjectConfigurator.java	(working copy)
@@ -15,7 +15,6 @@
 
 import org.apache.maven.artifact.Artifact;
 import org.apache.maven.artifact.resolver.filter.ArtifactFilter;
-import org.apache.maven.model.Dependency;
 import org.apache.maven.project.MavenProject;
 import org.eclipse.core.resources.IProject;
 import org.eclipse.core.resources.ProjectScope;
@@ -24,13 +23,13 @@
 import org.eclipse.core.runtime.preferences.IScopeContext;
 import org.eclipse.jdt.core.JavaCore;
 import org.eclipse.jface.preference.IPreferenceStore;
+import org.eclipse.m2e.core.project.IMavenProjectFacade;
+import org.eclipse.m2e.core.project.MavenProjectChangedEvent;
+import org.eclipse.m2e.core.project.configurator.AbstractProjectConfigurator;
+import org.eclipse.m2e.core.project.configurator.ProjectConfigurationRequest;
 import org.hibernate.eclipse.console.properties.HibernatePropertiesConstants;
 import org.hibernate.eclipse.console.utils.ProjectUtils;
 import org.jboss.tools.maven.ui.Activator;
-import org.maven.ide.eclipse.project.IMavenProjectFacade;
-import org.maven.ide.eclipse.project.MavenProjectChangedEvent;
-import org.maven.ide.eclipse.project.configurator.AbstractProjectConfigurator;
-import org.maven.ide.eclipse.project.configurator.ProjectConfigurationRequest;
 import org.osgi.service.prefs.Preferences;
 
 /**
Index: plugins/org.jboss.tools.maven.hibernate/src/org/jboss/tools/maven/hibernate/MavenHibernateActivator.java
===================================================================
--- plugins/org.jboss.tools.maven.hibernate/src/org/jboss/tools/maven/hibernate/MavenHibernateActivator.java	(revision 32612)
+++ plugins/org.jboss.tools.maven.hibernate/src/org/jboss/tools/maven/hibernate/MavenHibernateActivator.java	(working copy)
@@ -1,3 +1,13 @@
+/*************************************************************************************
+ * Copyright (c) 2008-2011 Red Hat, Inc. and others.
+ * All rights reserved. This program and the accompanying materials 
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ * 
+ * Contributors:
+ *     JBoss by Red Hat - Initial implementation.
+ ************************************************************************************/
 package org.jboss.tools.maven.hibernate;
 
 import org.eclipse.ui.plugin.AbstractUIPlugin;
